(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/platform-browser/animations'), require('@angular/animations/browser')) :
	typeof define === 'function' && define.amd ? define(['exports', '@angular/core', '@angular/platform-browser/animations', '@angular/animations/browser'], factory) :
	(factory((global.ngx = global.ngx || {}, global.ngx.noAnimation = global.ngx.noAnimation || {}),global.ng.core,global._angular_platformBrowser_animations,global._angular_animations_browser));
}(this, (function (exports,_angular_core,_angular_platformBrowser_animations,_angular_animations_browser) { 'use strict';

/**
 * @param {?} ua
 * @return {?}
 */
function isBrowserSupport(ua) {
    if (!!window['chrome'] && !!window['chrome']['webstore']) {
        return true;
    }
    else if (ua.indexOf('Firefox') !== -1) {
        var /** @type {?} */ match = /((?!Gecko.+)Firefox|Gecko(?!.+Firefox))(?: |\/)([\d]+)/.exec(ua);
        var /** @type {?} */ ver = +match[2];
        return !!match[1] && !isNaN(ver) && ver >= 27; // Firefox 27+
    }
    else if (ua.indexOf('Safari') !== -1) {
        var /** @type {?} */ match = /(?:iPod|iPhone|iPad).+Version\/(\d+\.\d+).*Safari/.exec(ua); // iOS safari 7.1+
        var /** @type {?} */ ver = match ? +match[1] : 0;
        if (!isNaN(ver)) {
            return ver >= 7.1;
        }
        match = /Version\/(\d+)\.\d+(?:\.\d+)?.*Safari/.exec(ua); // OS X Safari 9+
        ver = match ? +match[1] : 0;
        if (!isNaN(ver)) {
            return ver >= 9;
        }
    }
    else if (ua.indexOf('MSIE') !== -1) {
        return ua.indexOf('MSIE 10') !== -1; // filter out all IE but IE10
    }
    else if (ua.indexOf('Edge') || ua.indexOf('Trident')) {
        return true; // IE11 and Edge
    }
    return false;
}

/**
 * @param {?} config
 * @return {?}
 */
function animationFactory(config) {
    var /** @type {?} */ noop = _angular_animations_browser.AnimationDriver.NOOP;
    var /** @type {?} */ driver = new _angular_animations_browser.ɵWebAnimationsDriver();
    var /** @type {?} */ isSupported = isBrowserSupport(window.navigator.userAgent);
    return {
        animate: function (element, keyframes, duration, delay, easing, previousPlayers) {
            if (!isSupported || config.disable) {
                return noop.animate(element, keyframes, duration, delay, easing, previousPlayers);
            }
            else {
                return driver.animate(element, keyframes, duration, delay, easing, previousPlayers);
            }
        }
    };
}

var CONFIG_TOKEN = new _angular_core.InjectionToken('config');
var BrowserSupportedAnimationsModule = (function () {
    function BrowserSupportedAnimationsModule() {
    }
    /**
     * @param {?=} config
     * @return {?}
     */
    BrowserSupportedAnimationsModule.forRoot = function (config) {
        return {
            ngModule: BrowserSupportedAnimationsModule,
            providers: [
                { provide: CONFIG_TOKEN, useValue: config },
                { provide: _angular_animations_browser.AnimationDriver, useFactory: animationFactory, deps: [CONFIG_TOKEN] }
            ]
        };
    };
    return BrowserSupportedAnimationsModule;
}());
BrowserSupportedAnimationsModule.decorators = [
    { type: _angular_core.NgModule, args: [{
                imports: [_angular_platformBrowser_animations.BrowserAnimationsModule]
            },] },
];
/**
 * @nocollapse
 */
BrowserSupportedAnimationsModule.ctorParameters = function () { return []; };

exports.BrowserSupportedAnimationsModule = BrowserSupportedAnimationsModule;
exports.animationFactory = animationFactory;

Object.defineProperty(exports, '__esModule', { value: true });

})));
