import { AnimationDriver, ɵWebAnimationsDriver } from '@angular/animations/browser';
import { isBrowserSupport } from './browser-detect';
/**
 * @param {?} config
 * @return {?}
 */
export function animationFactory(config) {
    var /** @type {?} */ noop = AnimationDriver.NOOP;
    var /** @type {?} */ driver = new ɵWebAnimationsDriver();
    var /** @type {?} */ isSupported = isBrowserSupport(window.navigator.userAgent);
    return {
        animate: function (element, keyframes, duration, delay, easing, previousPlayers) {
            if (!isSupported || config.disable) {
                return noop.animate(element, keyframes, duration, delay, easing, previousPlayers);
            }
            else {
                return driver.animate(element, keyframes, duration, delay, easing, previousPlayers);
            }
        }
    };
}
;
//# sourceMappingURL=animation.factory.js.map