import { NgModule, InjectionToken } from '@angular/core';
import { BrowserAnimationsModule } from '@angular/platform-browser/animations';
import { AnimationDriver } from '@angular/animations/browser';
import { animationFactory } from './animation.factory';
export { animationFactory } from './animation.factory';
var /** @type {?} */ CONFIG_TOKEN = new InjectionToken('config');
var BrowserSupportedAnimationsModule = (function () {
    function BrowserSupportedAnimationsModule() {
    }
    /**
     * @param {?=} config
     * @return {?}
     */
    BrowserSupportedAnimationsModule.forRoot = function (config) {
        return {
            ngModule: BrowserSupportedAnimationsModule,
            providers: [
                { provide: CONFIG_TOKEN, useValue: config },
                { provide: AnimationDriver, useFactory: animationFactory, deps: [CONFIG_TOKEN] }
            ]
        };
    };
    return BrowserSupportedAnimationsModule;
}());
export { BrowserSupportedAnimationsModule };
BrowserSupportedAnimationsModule.decorators = [
    { type: NgModule, args: [{
                imports: [BrowserAnimationsModule]
            },] },
];
/**
 * @nocollapse
 */
BrowserSupportedAnimationsModule.ctorParameters = function () { return []; };
function BrowserSupportedAnimationsModule_tsickle_Closure_declarations() {
    /** @type {?} */
    BrowserSupportedAnimationsModule.decorators;
    /**
     * @nocollapse
     * @type {?}
     */
    BrowserSupportedAnimationsModule.ctorParameters;
}
//# sourceMappingURL=index.js.map